import { Observable, Subject } from "rxjs";
import dotenv from 'dotenv';
import { AdaptorTransmissionRole, AdaptorBase, ConnectionState, Transport, TransportEvent, TransportService, AdapterProfile } from "../interface/connector.interface";

dotenv.config();
/* This transport manager will be instantiating the necessary transport to deal with tranmission and receiving from different receivers
So how?: */
export class Adapter implements AdaptorBase {
    event!: Subject<TransportEvent>
    connector!: TransportService;
    connectorProfile!: AdapterProfile;
    connectionStateBus!: Subject<ConnectionState>;
    adaptorTransmissionRole!: AdaptorTransmissionRole;

    constructor() {
        //logic here
    }

    getInfo(): AdapterProfile {
        // throw new Error("Method not implemented.");
        return this.connectorProfile
    }
    subscribeConnectionState(): Observable<ConnectionState> {
        throw new Error("Method not implemented.");
    }
    publishConnectionState(): void {
        throw new Error("Method not implemented.");
    }
    connect(): void {
        throw new Error("Method not implemented.");
    }
    disconnect(): void {
        throw new Error("Method not implemented.");
    }
    setAdapterProfile(id: string, transportType: Transport): void {
        throw new Error("Method not implemented.");
    }
}


